Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | METHOD | DETAIL: FIELD | METHOD

## org.gradle.api.artifacts
[Java] Interface ModuleDependency

    org.gradle.api.artifacts.ModuleDependency
      org.gradle.tooling.model.Dependency

All Superinterfaces:
  Dependency

    public interface ModuleDependency
    extends Dependency

A `ModuleDependency` is a Dependency on a module outside the current project.

A module dependency is an entity. Its key consists of the fields `group, name, version, configuration`.

Method Summary
`ModuleDependency` | `addArtifact(DependencyArtifact artifact)` Adds an artifact to this dependency.
`DependencyArtifact` | `artifact(groovy.lang.Closure configureClosure)` Adds an artifact to this dependency.
`ModuleDependency` | `copy()` {@inheritDoc}
`ModuleDependency` | `exclude(java.util.Map excludeProperties)` Adds an exclude rule to exclude transitive dependencies of this dependency.
`java.util.Set` | `getArtifacts()` Returns the artifacts belonging to this dependency.
`java.lang.String` | `getConfiguration()` Returns the configuration of this dependency module (not the configurations this dependency belongs too).
`java.util.Set` | `getExcludeRules()` Returns the exclude rules for this dependency.
`boolean` | `isTransitive()` Returns whether this dependency should be resolved including or excluding its transitive dependencies.
`ModuleDependency` | `setTransitive(boolean transitive)` Sets whether this dependency should be resolved including or excluding its transitive dependencies.

Method Detail

### addArtifact

    public ModuleDependency addArtifact(DependencyArtifact artifact)

  Adds an artifact to this dependency.

  If no artifact is added to a dependency, an implicit default artifact is used. This default artifact has the same name as the module and its type and extension is jar. If at least one artifact is explicitly added, the implicit default artifact won't be used any longer.

  Returns:
    this

### artifact

    public DependencyArtifact artifact(groovy.lang.Closure configureClosure)

  Adds an artifact to this dependency. The given closure is passed a DependencyArtifact instance, which it can configure.

  If no artifact is added to a dependency, an implicit default artifact is used. This default artifact has the same name as the module and its type and extension is jar. If at least one artifact is explicitly added, the implicit default artifact won't be used any longer.

  Returns:
    this

### copy

    public ModuleDependency copy()

  {@inheritDoc}

### exclude

    public ModuleDependency exclude(java.util.Map excludeProperties)

  Adds an exclude rule to exclude transitive dependencies of this dependency. You can also add exclude rules per-configuration. See Configuration#getExcludeRules()#getExcludeRules().
  Parameters:
    `excludeProperties` - the properties to define the exclude rule.
  Returns:
    this

### getArtifacts

    public java.util.Set getArtifacts()

  Returns the artifacts belonging to this dependency.
  See Also:
    addArtifact(DependencyArtifact)

### getConfiguration

    public java.lang.String getConfiguration()

  Returns the configuration of this dependency module (not the configurations this dependency belongs too). Never returns null. The default value for the configuration is DEFAULT_CONFIGURATION. A dependency source might have multiple configurations. Every configuration represents a different set of artifacts and dependencies for this dependency module.

### getExcludeRules

    public java.util.Set getExcludeRules()

  Returns the exclude rules for this dependency.
  See Also:
    exclude(java.util.Map)

### isTransitive

    public boolean isTransitive()

  Returns whether this dependency should be resolved including or excluding its transitive dependencies.
  See Also:
    setTransitive(boolean)

### setTransitive

    public ModuleDependency setTransitive(boolean transitive)

  Sets whether this dependency should be resolved including or excluding its transitive dependencies. The artifacts belonging to this dependency might themselve have dependencies on other artifacts. The latter are called transitive dependencies.
  Parameters:
    `transitive` - Whether transitive dependencies should be resolved.
  Returns:
    this

Groovy Documentation